﻿/*
Draggable point
*/

package {
	import flash.events.*;
	import flash.display.*;
	
	public class DraggablePoint extends MovieClip {

		var isBezier:Boolean;

		public function DraggablePoint() {
			addEventListener(MouseEvent.MOUSE_DOWN, startToDrag);
			useHandCursor = true;
			buttonMode = true;
			addEventListener(MouseEvent.CLICK, function() {});
		}

		private function startToDrag(e:MouseEvent):void {
			startDrag();
			parent.setChildIndex(this, parent.numChildren - 1);
			Main(Viewport(parent).parent).stopTravel();
			var i:uint;
			Main(Viewport(parent).parent).setSelectedPoint(i);
			for (i = 0; i < Viewport(parent).controlPoints.length; i++) {
				if (Viewport(parent).controlPoints[i] == this) {
					Main(Viewport(parent).parent).setSelectedPoint(i);
				}
			}
			addEventListener(MouseEvent.MOUSE_UP, stopToDrag);
			addEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
		}
		private function stopToDrag(e:MouseEvent):void {
			stopDrag();
//			Main(parent).startTravel();
			removeEventListener(MouseEvent.MOUSE_UP, stopToDrag);
			removeEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
		}
		private function mouseMove(e:MouseEvent):void {
			Viewport(parent).updatePoints();
			e.updateAfterEvent();
		}
	}
}
